#include <stdio.h>
#include <string.h>
#include <Rabbit2000.h>
#include "rabbitlwip.h"


far void main(void)
{
    // Dummy configuration, will be overwritten by DHCP
    NetConfig config;
    NetConnectionConfig interface;
    struct netif *network;
    char MACString[20];
    int productID;

    WDT_DISABLE();

    // Clear the Softools WinIDE print buffer from any previous program runs
    printf("\x1A");
    productID = netRecognize();
    config.hostName = "test";
    config.domainName = "toman.org";
    netStringToIP("192.168.10.1", &config.defaultGateway);
    netConfigure(&config);

    // Start ethernet with DHCP using default handlers (will respond to
    // ICMP echo requests)
    printf("** Starting Ethernet Interface **\n");
    printf("Rabbit 2000/3000 board or core module %s recognized\n",
           (productID ? "is" : "is not"));

    interface.connType = ETH_CONN;
    netStringToIP("192.168.10.40", &interface.address);
    netStringToIP("255.255.255.0", &interface.netmask);

    // Netmasks of the form 192.168.1.255 will fail!

    // Start timer up. This *must* be done or the TCP/IP stack may not
    // behave correctly.
    // Interrupt handler to process incoming packets runs at regular
    // intervals (in this case 50 times per second, which is every 20ms).
    // Note that the ethernet doesn't have to be started to run this timer.
    startTimer(50, netProcess, 2);
    ipset1();

    // Start ethernet interface
    network = ethernetStart(&interface, NET_USE_DHCP, "192.168.10.2", NULL);
    printf("MAC: %s\n", netGetMAC(MACString, network));
    if (network == NULL)
    {
        // Error code: ethernet initialization failed somehow
        printf("Ethernet initialization failed");
    }
    else
    {
        // Successful initialization
        char name[HOSTNAME_LENGTH];
        //longword address;
        //eth_address addr;

        printf("Ethernet initialization succeeded\n");
        printf("hostname: %s\n", netGetHostName());
        printf("domain: %s\n", netGetDomainName());
        printf("ip: %s\n", netIPToString(&network->ip_addr, name));

        // Get some ARP lookups going
        //_arp_resolve(inet_addr("192.168.1.1"), &addr, 0);
        //printf("192.168.1.1 -> %s\n", etherAddressToString(name, &addr));
        //_arp_resolve(inet_addr("192.168.1.2"), &addr, 0);
        //printf("192.168.1.2 -> %s\n", etherAddressToString(name, &addr));
        //_arp_resolve(inet_addr("192.168.1.8"), &addr, 0);
        //printf("192.168.1.8 -> %s\n", etherAddressToString(name, &addr));

        // Do a test DNS lookup

        //address = resolve("www.compendium-tech.com");
        //printf("DNS: www.compendium-tech.com resolves to %s\n",
        //       inet_ntoa(name, address));
        //address = resolve("www.softools.com");
        //printf("DNS: www.softools.com resolves to %s\n",
        //       inet_ntoa(name, address));
        //address = resolve("www.espn.com");
        //printf("DNS: www.espn.com resolves to %s\n",
        //       inet_ntoa(name, address));
        //address = resolve("www.cnn.com");
        //printf("DNS: www.cnn.com resolves to %s\n",
        //       inet_ntoa(name, address));
        //address = resolve("www.toman.ws");
        //printf("DNS: www.toman.ws resolves to %s\n",
        //       inet_ntoa(name, address));
        //address = resolve("www.padres.com");
        //printf("DNS: www.padres.com resolves to %s\n",
        //       inet_ntoa(name, address));
        //address = resolve("www.kernel.org");
        //printf("DNS: www.kernel.org resolves to %s\n",
        //       inet_ntoa(name, address));

        printf("looping\n");
        while(1)
            netProcess(); // Loop forever. Rabbit device should be pingable.
    }

}
